<?php
ob_start("ob_gzhandler");
session_start();

if (empty($_SESSION['uid'])) {
    header("Location: index.php");
    exit;
}
require_once "functions.php";
$user = $user ?? [];
if ($user->room != 29) {
    header("Location: main.php");
    exit;
}
if ($user->battle != 0) {
    header('location: fbattle.php');
    exit;
}
const BANK_SESSION_NAME = "bankid";
const SUCCESS = "Успешная операция!";
$get = urldecode(filter_input(INPUT_SERVER, 'QUERY_STRING'));
if ($get == 'exit') {
    $_SESSION[BANK_SESSION_NAME] = null;
}
$bank = new Bank($user->id);
$status = '';

if (isset($_POST['userlogin'])) {
    $_SESSION[BANK_SESSION_NAME] = $bank->user_id;
}
if ($_SESSION[BANK_SESSION_NAME]) {
    $toid = (int)$_POST['to_id'] ?? 0;
    $summa = (int)$_POST['summa'] ?? 0;
    $submit = $_POST['action'] ?? '';
    // Зачисление кредитов на счёт.
    if ($submit === 'depositMoney' && $summa) {
        $bank->depositMoney($summa);
        $status = SUCCESS;
    }
    // Снятие кредитов со счёта.
    if ($submit === 'withdrawMoney' && $summa) {
        $bank->withdrawMoney($summa);
        $status = SUCCESS;
    }
    // Перевод кредитов на другой счёт.
    if ($submit === 'sendMoney' && $summa && $toid) {
        $bank->sendMoney($toid, $summa);
        $status = SUCCESS;
    }
    unset($submit, $summa, $toid);
}
Template::header('Банк');
?>
    <link href="css/secondary.css" rel="stylesheet"/>
    <script src="js/main.js"></script>
<h1>Банк</h1>
<?php if (!$_SESSION[BANK_SESSION_NAME]): ?>
    <a href=# onclick=hrefToFrame('city.php?strah')> ← выйти из банка</a>
    <form method="post"><input type="submit" name="userlogin" value="Управление счётом"></form>
<?php else: ?>
    <p><a href="?exit"> ← выйти из счёта</a></p>
    <div><?= $status ?></div>
    <div class="appblock appblock-main">
        <span class="legend">Cчет №<?= $bank->user_id ?></span>
        <span class="wrap">На счету: <span class="num"><?= $bank->money ?></span></span>
        <hr>
        <span class="wrap">На руках: <span class="num"><?= $user['money'] ?></span></span>
    </div>
    <div class="appblock">
        <span class="legend">Работа со счётом</span>
        <form method="post">
            <input size="10" name="summa" placeholder="Сумма">
            <input type="hidden" name="action" value="depositMoney">
            <input type="submit" value="Положить деньги">
        </form>
        <form method="post">
            <input size="10" name="summa" placeholder="Сумма">
            <input type="hidden" name="action" value="withdrawMoney">
            <input type="submit" value="Снять деньги">
        </form>
    </div>
    <div class="appblock">
        <span class="legend">Перевод кредитов</span>
        <form method="post">
            <input size="10" name="summa" placeholder="Сумма">
            <input size="10" name="to-id" placeholder="Cчёт"><br>
            <input type="hidden" name="action" value="sendMoney">
            <input type="submit" value="Перевести кредиты">
        </form>
        <span class="wrap">Комиссия: <?= Config::$bank_comission * 100 ?>% от переводимой суммы, но не менее 1 кр.</span>
    </div>
<?php endif; ?>